Merge remote-tracking branch 'mvo/feature/apt-update-info' into debian/sid
[ntk/apt.git] / prepare-release
1 #!/bin/sh
2 set -e
3
4 cd "$(readlink -f $(dirname $0))"
5
6 if [ -n "${GBP_BUILD_DIR}" ]; then
7 cd "$GBP_BUILD_DIR"
8 fi
9
10 VERSION=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
11 DISTRIBUTION=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
12
13 LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/contrib/macros.h | sed 's/\.$//')"
14 LIBAPTINSTVERSION="$(egrep '^MAJOR=' apt-inst/makefile |cut -d '=' -f 2)"
15
16 librarysymbolsfromfile() {
17 local MISSING="$(grep '^+#MISSING' "$1")"
18 echo '=== Missing optional symbols:'
19 echo -n "$MISSING" | grep '|optional=' || true
20 echo '=== Missing required symbols:'
21 echo -n "$MISSING" | grep -v '|optional=' || true
22 echo '=== New symbols:'
23 grep '^+ ' "$1" | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
24 echo " (c++)\"${line}@Base\" $VERSION"
25 done | sort -u
26 }
27
28 if [ "$1" = 'pre-export' ]; then
29 libraryversioncheck() {
30 local LIBRARY="$1"
31 local VERSION="$2"
32 if [ ! -e "debian/${LIBRARY}${VERSION}.symbols" ]; then
33 echo >&2 "Library ${LIBRARY} in version ${VERSION} has no symbols file! (maybe forgot to rename?)"
34 exit 1
35 fi
36 if [ "$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")" != "${LIBRARY}.so.${VERSION} ${LIBRARY}${VERSION} #MINVER#" ]; then
37 echo >&2 "Library ${LIBRARY}${VERSION} has incorrect version in symbol header! (»$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")«)"
38 exit 2
39 fi
40 }
41
42 libraryversioncheck 'libapt-pkg' "$LIBAPTPKGVERSION"
43 libraryversioncheck 'libapt-inst' "$LIBAPTINSTVERSION"
44
45
46 if [ "$DISTRIBUTION" = 'sid' ]; then
47 echo >&2 '»sid« is not a valid distribution. Replace it with »unstable« for you'
48 sed -i -e 's/) sid; urgency=/) unstable; urgency=/' debian/changelog
49 DISTRIBUTION='unstable'
50 elif [ "$DISTRIBUTION" = 'UNRELEASED' ]; then
51 echo >&2 'WARNING: Remember to change to a valid distribution for release'
52 VERSION="$VERSION~$(date +%Y%m%d)"
53 fi
54
55 if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
56 "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
57 echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
58 make update-po
59 fi
60
61 sed -i -e "s/^PACKAGE_VERSION=\".*\"$/PACKAGE_VERSION=\"${VERSION}\"/" configure.ac
62 sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
63 elif [ "$1" = 'post-build' ]; then
64 if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
65 echo >&2 "REMEMBER: Tag this release with »git tag ${VERSION}« if you are satisfied"
66 else
67 echo >&2 'REMEMBER: Change to a valid distribution before release'
68 fi
69
70 dpkg-checkbuilddeps -d 'libxml2-utils'
71
72 # check the manpages with each vendor for vendor-specific errors…
73 find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
74 ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
75 if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
76 echo >&2 "WARNING: original docbook manpages have errors with vendor ${DISTRO}!"
77 fi
78 done
79 # lets assume we will always have a german manpage translation
80 if [ -e 'doc/de/' ]; then
81 # … but check the translations only with one vendor for translation-specific errors
82 if ! xmllint --nonet --valid --noout $(find doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
83 echo >&2 "WARNING: translated docbook manpages have errors!"
84 fi
85 else
86 echo >&2 "ERROR: translated manpages need to be build before they can be checked!"
87 fi
88 rm -f doc/apt-vendor.ent
89
90 elif [ "$1" = 'library' ]; then
91 librarysymbols() {
92 echo "Checking $1 in version $2"
93 local tmpfile=$(mktemp)
94 dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
95 librarysymbolsfromfile "$tmpfile"
96 rm -f $tmpfile
97 }
98 librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
99 echo
100 librarysymbols 'libapt-inst' "${LIBAPTINSTVERSION}"
101 elif [ "$1" = 'buildlog' ]; then
102 while [ -n "$2" ]; do
103 librarysymbolsfromfile "$2"
104 shift
105 done
106 elif [ "$1" = 'travis-ci' ]; then
107 apt-get install -q --no-install-recommends $(sed -n -e '/^Build-Depends: /,/^Build-Depends-Indep: / {p}' debian/control | sed -e 's#([^)]*)##g' -e 's#^Build-Depends\(-Indep\)\?: ##' | tr -d ',')
108 else
109 echo >&1 "Usage:\t$0 pre-export
110 \t$0 post-build
111 \t$0 library
112
113 If you use »git buildpackage« you can leave this script alone as it will
114 be run at the right places auto-magically. Otherwise you should use
115 »pre-export« to update po and pot files as well as version numbering.
116 »post-build« can be used to run some more or less useful checks later on.
117
118 »library« isn't run automatically but can be useful for maintaining the
119 (more or less experimental) symbols files we provide"
120 fi